/*
 * polylib.h  V4.12
 */

/* WARNING: you should not include directly this file, but use
   polylib32.h or polylib64.h (for 32 or 64 bits integers).
*/

#if ! defined(LINEAR_VALUE_IS_LONGLONG) \
	&& ! defined(LINEAR_VALUE_IS_LONG) \
	&& ! defined(LINEAR_VALUE_IS_INT) \
	&& ! defined(LINEAR_VALUE_IS_CHARS)
#error Please define LINEAR_VALUE_IS_* or #include polylib32.h or polylib64.h
#endif

#include <polylib/arithmetique.h>
#include <polylib/arithmetic_errors.h>

#include <polylib/types.h>

#include <polylib/errormsg.h>
#include <polylib/vector.h>
#include <polylib/matrix.h>
#include <polylib/polyhedron.h>
#include <polylib/polyparam.h>
#include <polylib/param.h>
#include <polylib/ehrhart.h>
#include <polylib/eval_ehrhart.h>

#ifdef GNUMP
#include <gmp.h>

#include <polylib/types_mp.h>
#include <polylib/matrix_mp.h>
#include <polylib/ehrhart_mp.h>
#endif
